"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Image;
var React = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function Image(props) {
  var _props$builderBlock;
  const shouldRenderUnwrappedChildren = props.fitContent && ((_props$builderBlock = props.builderBlock) === null || _props$builderBlock === void 0 || (_props$builderBlock = _props$builderBlock.children) === null || _props$builderBlock === void 0 ? void 0 : _props$builderBlock.length);
  const imageStyle = props.aspectRatio ? {
    position: 'absolute',
    top: 0,
    bottom: 0,
    left: 0,
    right: 0
  } : {
    position: 'relative',
    ...(props.width ? {
      width: props.width
    } : {}),
    ...(props.height ? {
      height: props.height
    } : {})
  };
  const paddingTop = `${props.aspectRatio * 100}%`;
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_reactNative.Image, {
    resizeMode: props.backgroundSize || 'contain',
    style: imageStyle,
    source: {
      uri: props.image
    }
  }), props.aspectRatio && !shouldRenderUnwrappedChildren ? /*#__PURE__*/React.createElement(_reactNative.View, {
    style: {
      width: '100%',
      paddingTop
    }
  }) : null), shouldRenderUnwrappedChildren && props.children, !props.fitContent && props.children &&
  /*#__PURE__*/
  // When `fitContent: false`, we wrap image children ssuch that they stretch across the entire image
  React.createElement(_reactNative.View, {
    style: {
      display: 'flex',
      flexDirection: 'column',
      alignItems: 'stretch',
      position: 'absolute',
      top: 0,
      left: 0,
      width: '100%',
      height: '100%'
    }
  }, props.children));
}
//# sourceMappingURL=image.js.map