"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var React = _react;
var _reactNative = require("react-native");
var _blocks = _interopRequireDefault(require("../../components/blocks/blocks"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function Tabs(props) {
  var _props$tabs;
  const [activeTab, setActiveTab] = (0, _react.useState)(() => props.defaultActiveTab ? props.defaultActiveTab - 1 : 0);
  function activeTabContent(active) {
    return props.tabs && props.tabs[active].content;
  }
  function onClick(index) {
    if (index === activeTab && props.collapsible) {
      setActiveTab(-1);
    } else {
      setActiveTab(index);
    }
  }
  return /*#__PURE__*/React.createElement(_reactNative.View, null, /*#__PURE__*/React.createElement(_reactNative.View, {
    style: {
      display: "flex",
      flexDirection: "row",
      justifyContent: props.tabHeaderLayout || "flex-start",
      overflow: "scroll"
    }
  }, (_props$tabs = props.tabs) === null || _props$tabs === void 0 ? void 0 : _props$tabs.map((tab, index) => /*#__PURE__*/React.createElement(_reactNative.Pressable, {
    key: index,
    style: {
      ...(activeTab === index ? props.activeTabStyle : {})
    },
    onPress: event => onClick(index)
  }, /*#__PURE__*/React.createElement(_blocks.default, {
    parent: props.builderBlock.id,
    path: `tabs.${index}.label`,
    blocks: tab.label,
    context: props.builderContext,
    registeredComponents: props.builderComponents,
    linkComponent: props.builderLinkComponent
  })))), activeTabContent(activeTab) ? /*#__PURE__*/React.createElement(_reactNative.View, null, /*#__PURE__*/React.createElement(_blocks.default, {
    parent: props.builderBlock.id,
    path: `tabs.${activeTab}.content`,
    blocks: activeTabContent(activeTab),
    context: props.builderContext,
    registeredComponents: props.builderComponents,
    linkComponent: props.builderLinkComponent
  })) : null);
}
var _default = exports.default = Tabs;
//# sourceMappingURL=tabs.js.map