"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.chooseBrowserOrServerEval = void 0;
var _isBrowser = require("../is-browser");
var _browser = require("./browser-runtime/browser");
var _index = require("./browser-runtime/index.js");
var _shouldForceBrowserRuntimeInNode = require("./should-force-browser-runtime-in-node");
/*
 * THIS FILE IS EXPECTED TO EXIST WITH THIS EXACT NAME BY SUBSEQUENT BUNDLE STEPS THAT TRANSFORM IT.
 * DO NOT RENAME THIS FILE.
 */

/**
 * THIS IS A MAGICAL IMPORT. It is aliased by the build process of every SDK configuration, so that
 * it points to the correct runtime for that configuration, which are expected to live exactly at:
 *  - ./browser-runtime/index.js
 *  - ./node-runtime/index.js
 *  - ./edge-runtime/index.js
 *
 * We have code in `/output-generation` that does this aliasing, and is re-used by each SDK.
 * Also, each individual `tsconfig.json` aliases this import to the browser runtime so that the
 * types can be resolved correctly.
 */

/**
 * Even though we have separate runtimes for browser/node/edge, sometimes frameworks will
 * end up sending the server runtime code to the browser (most notably in dev mode).
 */
const chooseBrowserOrServerEval = args => (0, _isBrowser.isBrowser)() || (0, _shouldForceBrowserRuntimeInNode.shouldForceBrowserRuntimeInNode)({
  shouldLogWarning: true
}) ? (0, _browser.runInBrowser)(args) : (0, _index.evaluator)(args);
exports.chooseBrowserOrServerEval = chooseBrowserOrServerEval;
//# sourceMappingURL=choose-eval.js.map