"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getBlockActions = getBlockActions;
var _target = require("../constants/target");
var _eventHandlerName = require("./event-handler-name");
var _getBlockActionsHandler = require("./get-block-actions-handler");
function getBlockActions(options) {
  const obj = {};
  const optionActions = options.block.actions ?? {};
  for (const key in optionActions) {
    // eslint-disable-next-line no-prototype-builtins
    if (!optionActions.hasOwnProperty(key)) {
      continue;
    }
    const value = optionActions[key];
    let eventHandlerName = (0, _eventHandlerName.getEventHandlerName)(key);
    if (options.stripPrefix) {
      switch (_target.TARGET) {
        case 'vue':
          eventHandlerName = eventHandlerName.replace('v-on:', '');
          break;
        case 'svelte':
          eventHandlerName = eventHandlerName.replace('on:', '');
          break;
      }
    }
    obj[eventHandlerName] = (0, _getBlockActionsHandler.createEventHandler)(value, options);
  }
  return obj;
}
//# sourceMappingURL=get-block-actions.js.map