"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.register = register;
exports.registerAction = registerAction;
var _isBrowser = require("./is-browser");
var _registerComponent = require("./register-component");
const registry = {};
function register(type, info) {
  if (type === 'plugin') {
    info = (0, _registerComponent.serializeIncludingFunctions)(info);
  }
  let typeList = registry[type];
  if (!typeList) {
    typeList = registry[type] = [];
  }
  typeList.push(info);
  if ((0, _isBrowser.isBrowser)()) {
    const message = {
      type: 'builder.register',
      data: {
        type,
        info
      }
    };
    try {
      parent.postMessage(message, '*');
      if (parent !== window) {
        window.postMessage(message, '*');
      }
    } catch (err) {
      console.debug('Could not postmessage', err);
    }
  }
}
function registerAction(action) {
  if ((0, _isBrowser.isBrowser)()) {
    var _window$parent;
    const actionClone = JSON.parse(JSON.stringify(action));
    if (action.action) {
      actionClone.action = action.action.toString();
    }
    (_window$parent = window.parent) === null || _window$parent === void 0 || _window$parent.postMessage({
      type: 'builder.registerAction',
      data: actionClone
    }, '*');
  }
}
//# sourceMappingURL=register.js.map