"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setLocalStorageItem = exports.getLocalStorageItem = void 0;
var _isBrowser = require("../functions/is-browser");
const getLocalStorage = () => (0, _isBrowser.isBrowser)() && typeof localStorage !== 'undefined' ? localStorage : undefined;
const getLocalStorageItem = ({
  key,
  canTrack
}) => {
  try {
    if (canTrack) {
      var _getLocalStorage;
      return (_getLocalStorage = getLocalStorage()) === null || _getLocalStorage === void 0 ? void 0 : _getLocalStorage.getItem(key);
    }
    return undefined;
  } catch (err) {
    console.debug('[LocalStorage] GET error: ', err);
    return undefined;
  }
};
exports.getLocalStorageItem = getLocalStorageItem;
const setLocalStorageItem = ({
  key,
  canTrack,
  value
}) => {
  try {
    if (canTrack) {
      var _getLocalStorage2;
      (_getLocalStorage2 = getLocalStorage()) === null || _getLocalStorage2 === void 0 || _getLocalStorage2.setItem(key, value);
    }
  } catch (err) {
    console.debug('[LocalStorage] SET error: ', err);
  }
};
exports.setLocalStorageItem = setLocalStorageItem;
//# sourceMappingURL=localStorage.js.map