function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import * as React from "react";
import { View } from "react-native";
import { useState, useRef, useEffect } from "react";
import Blocks from "../../components/blocks/blocks";
import InlinedScript from "../../components/inlined-script";
import InlinedStyles from "../../components/inlined-styles";
import { TARGET } from "../../constants/target";
import { getClassPropName } from "../../functions/get-class-prop-name";
import { isEditing } from "../../functions/is-editing";
import { isPreviewing } from "../../functions/is-previewing";
import { getDefaultCanTrack } from "../../helpers/canTrack";
import { userAttributesService } from "../../helpers/user-attributes";
import { checkShouldRenderVariants, DEFAULT_INDEX, filterWithCustomTargeting, getBlocksToRender, getPersonalizationScript, getUpdateVisibilityStylesScript, SDKS_REQUIRING_RESET_APPROACH } from "./helpers";
function PersonalizationContainer(props) {
  var _props$builderBlock5, _props$builderContext8, _props$builderBlock6, _props$builderContext9, _props$builderBlock7, _props$builderContext10, _props$builderBlock8, _props$variants, _props$builderBlock13, _props$builderContext13, _props$builderBlock14, _props$builderContext14, _props$builderBlock15;
  const rootRef = useRef(null);
  const [userAttributes, setUserAttributes] = useState(() => userAttributesService.getUserAttributes());
  const [scriptStr, setScriptStr] = useState(() => {
    var _props$builderBlock, _props$builderContext;
    return getPersonalizationScript(props.variants, ((_props$builderBlock = props.builderBlock) === null || _props$builderBlock === void 0 ? void 0 : _props$builderBlock.id) || "none", (_props$builderContext = props.builderContext) === null || _props$builderContext === void 0 || (_props$builderContext = _props$builderContext.rootState) === null || _props$builderContext === void 0 ? void 0 : _props$builderContext.locale);
  });
  const [updateVisibilityStylesScript, setUpdateVisibilityStylesScript] = useState(() => {
    var _props$builderBlock2, _props$builderContext2;
    return getUpdateVisibilityStylesScript(props.variants, ((_props$builderBlock2 = props.builderBlock) === null || _props$builderBlock2 === void 0 ? void 0 : _props$builderBlock2.id) || "none", (_props$builderContext2 = props.builderContext) === null || _props$builderContext2 === void 0 || (_props$builderContext2 = _props$builderContext2.rootState) === null || _props$builderContext2 === void 0 ? void 0 : _props$builderContext2.locale);
  });
  const [unsubscribers, setUnsubscribers] = useState(() => []);
  const [shouldRenderVariants, setShouldRenderVariants] = useState(() => {
    var _props$builderContext3;
    return checkShouldRenderVariants(props.variants, getDefaultCanTrack((_props$builderContext3 = props.builderContext) === null || _props$builderContext3 === void 0 ? void 0 : _props$builderContext3.canTrack));
  });
  const [shouldResetVariants, setShouldResetVariants] = useState(() => false);
  function attrs() {
    return {
      ...props.attributes,
      ...{},
      [getClassPropName()]: `builder-personalization-container ${props.attributes[getClassPropName()] || ""}`
    };
  }
  function filteredVariants() {
    return (props.variants || []).filter(variant => {
      var _props$builderContext4, _props$builderContext5;
      return filterWithCustomTargeting({
        ...((_props$builderContext4 = props.builderContext) !== null && _props$builderContext4 !== void 0 && (_props$builderContext4 = _props$builderContext4.rootState) !== null && _props$builderContext4 !== void 0 && _props$builderContext4.locale ? {
          locale: (_props$builderContext5 = props.builderContext) === null || _props$builderContext5 === void 0 || (_props$builderContext5 = _props$builderContext5.rootState) === null || _props$builderContext5 === void 0 ? void 0 : _props$builderContext5.locale
        } : {}),
        ...userAttributes
      }, variant.query, variant.startDate, variant.endDate);
    });
  }
  function blocksToRender() {
    var _props$builderBlock3;
    return getBlocksToRender({
      variants: props.variants,
      fallbackBlocks: (_props$builderBlock3 = props.builderBlock) === null || _props$builderBlock3 === void 0 ? void 0 : _props$builderBlock3.children,
      isHydrated: shouldResetVariants,
      filteredVariants: filteredVariants(),
      previewingIndex: props.previewingIndex
    });
  }
  function hideVariantsStyleString() {
    return (props.variants || []).map((_, index) => {
      var _props$builderBlock4;
      return `div[data-variant-id="${(_props$builderBlock4 = props.builderBlock) === null || _props$builderBlock4 === void 0 ? void 0 : _props$builderBlock4.id}-${index}"] { display: none !important; } `;
    }).join("");
  }
  useEffect(() => {
    setShouldResetVariants(true);
    const unsub = userAttributesService.subscribeOnUserAttributesChange(attrs => {
      setUserAttributes(attrs);
    }, {
      fireImmediately: TARGET === "qwik"
    });
    if (!(isEditing() || isPreviewing())) {
      const variant = filteredVariants()[0];
      if (rootRef.current) {
        var _props$builderContext6;
        rootRef.current.dispatchEvent(new CustomEvent("builder.variantLoaded", {
          detail: {
            variant: variant || DEFAULT_INDEX,
            content: (_props$builderContext6 = props.builderContext) === null || _props$builderContext6 === void 0 ? void 0 : _props$builderContext6.content
          },
          bubbles: true
        }));
        const observer = new IntersectionObserver(entries => {
          entries.forEach(entry => {
            if (entry.isIntersecting && rootRef.current) {
              var _props$builderContext7;
              rootRef.current.dispatchEvent(new CustomEvent("builder.variantDisplayed", {
                detail: {
                  variant: variant || DEFAULT_INDEX,
                  content: (_props$builderContext7 = props.builderContext) === null || _props$builderContext7 === void 0 ? void 0 : _props$builderContext7.content
                },
                bubbles: true
              }));
            }
          });
        });
        observer.observe(rootRef.current);
      }
    }
    unsubscribers.push(unsub);
  }, []);
  useEffect(() => {
    return () => {
      unsubscribers.forEach(unsub => unsub());
    };
  }, []);
  return /*#__PURE__*/React.createElement(View, _extends({
    ref: rootRef
  }, attrs()), shouldResetVariants && SDKS_REQUIRING_RESET_APPROACH.includes(TARGET) ? /*#__PURE__*/React.createElement(Blocks, {
    blocks: blocksToRender().blocks,
    parent: (_props$builderBlock5 = props.builderBlock) === null || _props$builderBlock5 === void 0 ? void 0 : _props$builderBlock5.id,
    path: blocksToRender().path,
    context: props.builderContext,
    registeredComponents: props.builderComponents,
    BlocksWrapperProps: {
      ...((_props$builderContext8 = props.builderContext) === null || _props$builderContext8 === void 0 ? void 0 : _props$builderContext8.BlocksWrapperProps),
      "data-variant-id": `${(_props$builderBlock6 = props.builderBlock) === null || _props$builderBlock6 === void 0 ? void 0 : _props$builderBlock6.id}-${blocksToRender().index}`
    }
  }) : null, !shouldResetVariants && SDKS_REQUIRING_RESET_APPROACH.includes(TARGET) || !SDKS_REQUIRING_RESET_APPROACH.includes(TARGET) ? /*#__PURE__*/React.createElement(React.Fragment, null, shouldRenderVariants ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(InlinedStyles, {
    nonce: ((_props$builderContext9 = props.builderContext) === null || _props$builderContext9 === void 0 ? void 0 : _props$builderContext9.nonce) || "",
    styles: hideVariantsStyleString(),
    id: `variants-styles-${(_props$builderBlock7 = props.builderBlock) === null || _props$builderBlock7 === void 0 ? void 0 : _props$builderBlock7.id}`
  }), /*#__PURE__*/React.createElement(InlinedScript, {
    nonce: ((_props$builderContext10 = props.builderContext) === null || _props$builderContext10 === void 0 ? void 0 : _props$builderContext10.nonce) || "",
    scriptStr: updateVisibilityStylesScript,
    id: `variants-visibility-script-${(_props$builderBlock8 = props.builderBlock) === null || _props$builderBlock8 === void 0 ? void 0 : _props$builderBlock8.id}`
  }), (_props$variants = props.variants) === null || _props$variants === void 0 ? void 0 : _props$variants.map((variant, index) => {
    var _props$builderBlock9, _props$builderContext11, _props$builderBlock10, _props$builderBlock11, _props$builderContext12, _props$builderBlock12;
    return /*#__PURE__*/React.createElement(Blocks, {
      key: `${(_props$builderBlock9 = props.builderBlock) === null || _props$builderBlock9 === void 0 ? void 0 : _props$builderBlock9.id}-${index}`,
      BlocksWrapperProps: {
        ...((_props$builderContext11 = props.builderContext) === null || _props$builderContext11 === void 0 ? void 0 : _props$builderContext11.BlocksWrapperProps),
        "aria-hidden": true,
        hidden: true,
        "data-variant-id": `${(_props$builderBlock10 = props.builderBlock) === null || _props$builderBlock10 === void 0 ? void 0 : _props$builderBlock10.id}-${index}`
      },
      blocks: variant.blocks,
      parent: (_props$builderBlock11 = props.builderBlock) === null || _props$builderBlock11 === void 0 ? void 0 : _props$builderBlock11.id,
      path: `component.options.variants.${index}.blocks`,
      context: props.builderContext,
      registeredComponents: props.builderComponents
    }, /*#__PURE__*/React.createElement(InlinedScript, {
      nonce: ((_props$builderContext12 = props.builderContext) === null || _props$builderContext12 === void 0 ? void 0 : _props$builderContext12.nonce) || "",
      scriptStr: scriptStr,
      id: `variants-script-${(_props$builderBlock12 = props.builderBlock) === null || _props$builderBlock12 === void 0 ? void 0 : _props$builderBlock12.id}-${index}`
    }));
  })) : null, /*#__PURE__*/React.createElement(Blocks, {
    blocks: blocksToRender().blocks,
    parent: (_props$builderBlock13 = props.builderBlock) === null || _props$builderBlock13 === void 0 ? void 0 : _props$builderBlock13.id,
    path: blocksToRender().path,
    context: props.builderContext,
    registeredComponents: props.builderComponents,
    BlocksWrapperProps: {
      ...((_props$builderContext13 = props.builderContext) === null || _props$builderContext13 === void 0 ? void 0 : _props$builderContext13.BlocksWrapperProps),
      "data-variant-id": `${(_props$builderBlock14 = props.builderBlock) === null || _props$builderBlock14 === void 0 ? void 0 : _props$builderBlock14.id}-${blocksToRender().index}`
    }
  }, shouldRenderVariants ? /*#__PURE__*/React.createElement(InlinedScript, {
    nonce: ((_props$builderContext14 = props.builderContext) === null || _props$builderContext14 === void 0 ? void 0 : _props$builderContext14.nonce) || "",
    scriptStr: scriptStr,
    id: `variants-script-${(_props$builderBlock15 = props.builderBlock) === null || _props$builderBlock15 === void 0 ? void 0 : _props$builderBlock15.id}-${DEFAULT_INDEX}`
  }) : null)) : null);
}
export default PersonalizationContainer;
//# sourceMappingURL=personalization-container.js.map