import * as React from "react";
import { View, Pressable } from "react-native";
import { useState } from "react";
import Blocks from "../../components/blocks/blocks";
function Tabs(props) {
  var _props$tabs;
  const [activeTab, setActiveTab] = useState(() => props.defaultActiveTab ? props.defaultActiveTab - 1 : 0);
  function activeTabContent(active) {
    return props.tabs && props.tabs[active].content;
  }
  function onClick(index) {
    if (index === activeTab && props.collapsible) {
      setActiveTab(-1);
    } else {
      setActiveTab(index);
    }
  }
  return /*#__PURE__*/React.createElement(View, null, /*#__PURE__*/React.createElement(View, {
    style: {
      display: "flex",
      flexDirection: "row",
      justifyContent: props.tabHeaderLayout || "flex-start",
      overflow: "scroll"
    }
  }, (_props$tabs = props.tabs) === null || _props$tabs === void 0 ? void 0 : _props$tabs.map((tab, index) => /*#__PURE__*/React.createElement(Pressable, {
    key: index,
    style: {
      ...(activeTab === index ? props.activeTabStyle : {})
    },
    onPress: event => onClick(index)
  }, /*#__PURE__*/React.createElement(Blocks, {
    parent: props.builderBlock.id,
    path: `tabs.${index}.label`,
    blocks: tab.label,
    context: props.builderContext,
    registeredComponents: props.builderComponents,
    linkComponent: props.builderLinkComponent
  })))), activeTabContent(activeTab) ? /*#__PURE__*/React.createElement(View, null, /*#__PURE__*/React.createElement(Blocks, {
    parent: props.builderBlock.id,
    path: `tabs.${activeTab}.content`,
    blocks: activeTabContent(activeTab),
    context: props.builderContext,
    registeredComponents: props.builderComponents,
    linkComponent: props.builderLinkComponent
  })) : null);
}
export default Tabs;
//# sourceMappingURL=tabs.js.map