import * as React from "react";
/**
 * This component renders a block's wrapper HTML element (from the block's `tagName` property).
 */

import { getBlockActions } from "../../../functions/get-block-actions";
import { getBlockProperties } from "../../../functions/get-block-properties";
import DynamicRenderer from "../../dynamic-renderer/dynamic-renderer";
function BlockWrapper(props) {
  return /*#__PURE__*/React.createElement(DynamicRenderer, {
    TagName: props.Wrapper,
    attributes: getBlockProperties({
      block: props.block,
      context: props.context
    }),
    actionAttributes: getBlockActions({
      block: props.block,
      rootState: props.context.rootState,
      rootSetState: props.context.rootSetState,
      localState: props.context.localState,
      context: props.context.context,
      stripPrefix: true
    })
  }, props.children);
}
export default BlockWrapper;
//# sourceMappingURL=block-wrapper.js.map