import { findDOMNode } from 'react-dom';
import { isEditing } from "./is-editing";
export function transformBlockProperties({
  properties
}) {
  if (!isEditing()) {
    return properties;
  }
  const id = properties['builder-id'];
  if (!id) {
    console.warn('No builder-id found on properties', properties);
  }
  properties.ref = ref => {
    if (isEditing()) {
      const el = findDOMNode(ref);
      if (el && !(el instanceof Text)) {
        el.setAttribute('builder-id', id);
        el.classList.add(id);
      }
    }
  };
  return properties;
}
//# sourceMappingURL=transform-block-properties.js.map