"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _BaseText = _interopRequireDefault(require("../../blocks/BaseText"));
var _react = _interopRequireWildcard(require("react"));
var React = _react;
var _reactNative = require("react-native");
var _target = require("../../constants/target");
var _getBlockComponentOptions = require("../../functions/get-block-component-options");
var _getProcessedBlock = require("../../functions/get-processed-block");
var _serverIndex = require("../../server-index");
var _block = require("./block.helpers");
var _blockStyles = _interopRequireDefault(require("./components/block-styles"));
var _blockWrapper = _interopRequireDefault(require("./components/block-wrapper"));
var _componentRef = _interopRequireDefault(require("./components/component-ref/component-ref"));
var _repeatedBlock = _interopRequireDefault(require("./components/repeated-block"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function Block(props) {
  var _blockComponent5, _childrenWithoutParen, _repeatItem2, _repeatItem3;
  function repeatItem() {
    return (0, _block.getRepeatItemData)({
      block: props.block,
      context: props.context
    });
  }
  const [_processedBlock, set_processedBlock] = (0, _react.useState)(() => ({
    value: null,
    update: false
  }));
  function processedBlock() {
    var _props$block$repeat;
    if (_processedBlock.value && !_processedBlock.update && !(0, _serverIndex.isPreviewing)()) {
      return _processedBlock.value;
    }
    const blockToUse = (_props$block$repeat = props.block.repeat) !== null && _props$block$repeat !== void 0 && _props$block$repeat.collection ? props.block : (0, _getProcessedBlock.getProcessedBlock)({
      block: props.block,
      localState: props.context.localState,
      rootState: props.context.rootState,
      rootSetState: props.context.rootSetState,
      context: props.context.context
    });
    _processedBlock.value = blockToUse;
    _processedBlock.update = false;
    return blockToUse;
  }
  function blockComponent() {
    return (0, _block.getComponent)({
      block: processedBlock(),
      registeredComponents: props.registeredComponents,
      model: props.context.model
    });
  }
  function Tag() {
    var _processedBlock$prope;
    const shouldUseLink = props.block.tagName === "a" || ((_processedBlock$prope = processedBlock().properties) === null || _processedBlock$prope === void 0 ? void 0 : _processedBlock$prope.href) || processedBlock().href;
    if (shouldUseLink) {
      return props.linkComponent || _BaseText.default;
    }
    return _reactNative.View;
  }
  function canShowBlock() {
    var _props$block$repeat2;
    if ((_props$block$repeat2 = props.block.repeat) !== null && _props$block$repeat2 !== void 0 && _props$block$repeat2.collection) {
      var _repeatItem;
      if (repeatItem !== null && repeatItem !== void 0 && (_repeatItem = repeatItem()) !== null && _repeatItem !== void 0 && _repeatItem.length) return true;
      return false;
    }
    const shouldHide = "hide" in processedBlock() ? processedBlock().hide : false;
    const shouldShow = "show" in processedBlock() ? processedBlock().show : true;
    return shouldShow && !shouldHide;
  }
  function childrenWithoutParentComponent() {
    var _blockComponent;
    /**
     * When there is no `componentRef`, there might still be children that need to be rendered. In this case,
     * we render them outside of `componentRef`.
     * NOTE: We make sure not to render this if `repeatItemData` is non-null, because that means we are rendering an array of
     * blocks, and the children will be repeated within those blocks.
     */
    const shouldRenderChildrenOutsideRef = !(blockComponent !== null && blockComponent !== void 0 && (_blockComponent = blockComponent()) !== null && _blockComponent !== void 0 && _blockComponent.component) && !repeatItem();
    return shouldRenderChildrenOutsideRef ? processedBlock().children ?? [] : [];
  }
  function componentRefProps() {
    var _blockComponent2, _blockComponent3, _blockComponent4;
    return {
      blockChildren: processedBlock().children ?? [],
      componentRef: blockComponent === null || blockComponent === void 0 || (_blockComponent2 = blockComponent()) === null || _blockComponent2 === void 0 ? void 0 : _blockComponent2.component,
      componentOptions: {
        ...(0, _getBlockComponentOptions.getBlockComponentOptions)(processedBlock(), props.context),
        ...(0, _block.provideBuilderBlock)(blockComponent(), processedBlock()),
        ...(0, _block.provideBuilderContext)(blockComponent(), props.context),
        ...(0, _block.provideLinkComponent)(blockComponent(), props.linkComponent),
        ...(0, _block.provideRegisteredComponents)(blockComponent(), props.registeredComponents, props.context.model)
      },
      context: {
        ...props.context,
        inheritedStyles: (0, _block.getInheritedStyles)({
          block: processedBlock(),
          context: props.context
        })
      },
      linkComponent: props.linkComponent,
      registeredComponents: props.registeredComponents,
      builderBlock: processedBlock(),
      includeBlockProps: (blockComponent === null || blockComponent === void 0 || (_blockComponent3 = blockComponent()) === null || _blockComponent3 === void 0 ? void 0 : _blockComponent3.noWrap) === true,
      isInteractive: !(blockComponent !== null && blockComponent !== void 0 && (_blockComponent4 = blockComponent()) !== null && _blockComponent4 !== void 0 && _blockComponent4.isRSC && _target.TARGET === "rsc")
    };
  }
  (0, _react.useEffect)(() => {}, []);
  (0, _react.useEffect)(() => {
    _processedBlock.update = true;
  });
  return /*#__PURE__*/React.createElement(React.Fragment, null, canShowBlock() ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_blockStyles.default, {
    block: processedBlock(),
    context: props.context
  }), !(blockComponent !== null && blockComponent !== void 0 && (_blockComponent5 = blockComponent()) !== null && _blockComponent5 !== void 0 && _blockComponent5.noWrap) ? /*#__PURE__*/React.createElement(React.Fragment, null, !repeatItem() ? /*#__PURE__*/React.createElement(_blockWrapper.default, {
    Wrapper: Tag(),
    block: processedBlock(),
    context: props.context
  }, /*#__PURE__*/React.createElement(_componentRef.default, {
    componentRef: componentRefProps().componentRef,
    componentOptions: componentRefProps().componentOptions,
    blockChildren: componentRefProps().blockChildren,
    context: componentRefProps().context,
    registeredComponents: componentRefProps().registeredComponents,
    linkComponent: componentRefProps().linkComponent,
    builderBlock: componentRefProps().builderBlock,
    includeBlockProps: componentRefProps().includeBlockProps,
    isInteractive: componentRefProps().isInteractive
  }), (_childrenWithoutParen = childrenWithoutParentComponent()) === null || _childrenWithoutParen === void 0 ? void 0 : _childrenWithoutParen.map(child => /*#__PURE__*/React.createElement(Block, {
    key: child.id,
    block: child,
    registeredComponents: props.registeredComponents,
    linkComponent: props.linkComponent,
    context: {
      ...props.context,
      inheritedStyles: (0, _block.getInheritedStyles)({
        block: processedBlock(),
        context: props.context
      })
    }
  }))) : /*#__PURE__*/React.createElement(React.Fragment, null, (_repeatItem2 = repeatItem()) === null || _repeatItem2 === void 0 ? void 0 : _repeatItem2.map((data, index) => /*#__PURE__*/React.createElement(_repeatedBlock.default, {
    key: (0, _block.generateKey)(index),
    repeatContext: data.context,
    block: data.block,
    registeredComponents: props.registeredComponents,
    linkComponent: props.linkComponent
  })))) : !repeatItem() ? /*#__PURE__*/React.createElement(_componentRef.default, {
    componentRef: componentRefProps().componentRef,
    componentOptions: componentRefProps().componentOptions,
    blockChildren: componentRefProps().blockChildren,
    context: componentRefProps().context,
    registeredComponents: componentRefProps().registeredComponents,
    linkComponent: componentRefProps().linkComponent,
    builderBlock: componentRefProps().builderBlock,
    includeBlockProps: componentRefProps().includeBlockProps,
    isInteractive: componentRefProps().isInteractive
  }) : /*#__PURE__*/React.createElement(React.Fragment, null, (_repeatItem3 = repeatItem()) === null || _repeatItem3 === void 0 ? void 0 : _repeatItem3.map((data, index) => /*#__PURE__*/React.createElement(_repeatedBlock.default, {
    key: (0, _block.generateKey)(index),
    repeatContext: data.context,
    block: data.block,
    registeredComponents: props.registeredComponents,
    linkComponent: props.linkComponent
  })))) : null);
}
var _default = exports.default = /*#__PURE__*/(0, _react.memo)(Block);
//# sourceMappingURL=block.js.map