"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var React = _react;
var _helpers = require("../../blocks/personalization-container/helpers");
var _target = require("../../constants/target");
var _abTests = require("../../helpers/ab-tests");
var _canTrack = require("../../helpers/canTrack");
var _content = _interopRequireDefault(require("../content/content"));
var _inlinedScript = _interopRequireDefault(require("../inlined-script"));
var _inlinedStyles = _interopRequireDefault(require("../inlined-styles"));
var _helpers2 = require("./helpers");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function ContentVariants(props) {
  var _getVariants;
  const [shouldRenderVariants, setShouldRenderVariants] = (0, _react.useState)(() => (0, _helpers2.checkShouldRenderVariants)({
    canTrack: (0, _canTrack.getDefaultCanTrack)(props.canTrack),
    content: props.content
  }));
  function updateCookieAndStylesScriptStr() {
    var _props$content;
    return (0, _helpers2.getUpdateCookieAndStylesScript)((0, _helpers2.getVariants)(props.content).map(value => ({
      id: value.testVariationId,
      testRatio: value.testRatio
    })), ((_props$content = props.content) === null || _props$content === void 0 ? void 0 : _props$content.id) || "");
  }
  function hideVariantsStyleString() {
    return (0, _helpers2.getVariants)(props.content).map(value => `.variant-${value.testVariationId} { display: none; } `).join("");
  }
  function defaultContent() {
    var _props$content2;
    return shouldRenderVariants ? {
      ...props.content,
      testVariationId: (_props$content2 = props.content) === null || _props$content2 === void 0 ? void 0 : _props$content2.id
    } : (0, _abTests.handleABTestingSync)({
      item: props.content,
      canTrack: (0, _canTrack.getDefaultCanTrack)(props.canTrack)
    });
  }
  (0, _react.useEffect)(() => {
    /**
     * For Solid/Svelte: we unmount the non-winning variants post-hydration.
     */
  }, []);
  return /*#__PURE__*/React.createElement(React.Fragment, null, !props.isNestedRender && _target.TARGET !== "reactNative" ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_inlinedScript.default, {
    id: "builderio-init-variants-fns",
    scriptStr: (0, _helpers2.getInitVariantsFnsScriptString)(),
    nonce: props.nonce || ""
  }), _helpers.SDKS_SUPPORTING_PERSONALIZATION.includes(_target.TARGET) ? /*#__PURE__*/React.createElement(_inlinedScript.default, {
    id: "builderio-init-personalization-variants-fns",
    nonce: props.nonce || "",
    scriptStr: (0, _helpers.getInitPersonalizationVariantsFnsScriptString)()
  }) : null) : null, shouldRenderVariants ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_inlinedStyles.default, {
    id: "builderio-variants",
    styles: hideVariantsStyleString(),
    nonce: props.nonce || ""
  }), /*#__PURE__*/React.createElement(_inlinedScript.default, {
    id: "builderio-variants-visibility",
    scriptStr: updateCookieAndStylesScriptStr(),
    nonce: props.nonce || ""
  }), (_getVariants = (0, _helpers2.getVariants)(props.content)) === null || _getVariants === void 0 ? void 0 : _getVariants.map(variant => /*#__PURE__*/React.createElement(_content.default, {
    apiHost: props.apiHost,
    isNestedRender: props.isNestedRender,
    key: variant.testVariationId,
    nonce: props.nonce,
    content: variant,
    showContent: false,
    model: props.model,
    data: props.data,
    context: props.context,
    apiKey: props.apiKey,
    apiVersion: props.apiVersion,
    customComponents: props.customComponents,
    linkComponent: props.linkComponent,
    canTrack: props.canTrack,
    locale: props.locale,
    enrich: props.enrich,
    isSsrAbTest: shouldRenderVariants,
    blocksWrapper: props.blocksWrapper,
    blocksWrapperProps: props.blocksWrapperProps,
    contentWrapper: props.contentWrapper,
    contentWrapperProps: props.contentWrapperProps,
    trustedHosts: props.trustedHosts,
    strictStyleMode: props.strictStyleMode
  }))) : null, /*#__PURE__*/React.createElement(_content.default, {
    apiHost: props.apiHost,
    nonce: props.nonce,
    isNestedRender: props.isNestedRender,
    strictStyleMode: props.strictStyleMode,
    content: defaultContent(),
    showContent: true,
    model: props.model,
    data: props.data,
    context: props.context,
    apiKey: props.apiKey,
    apiVersion: props.apiVersion,
    customComponents: props.customComponents,
    linkComponent: props.linkComponent,
    canTrack: props.canTrack,
    locale: props.locale,
    enrich: props.enrich,
    isSsrAbTest: shouldRenderVariants,
    blocksWrapper: props.blocksWrapper,
    blocksWrapperProps: props.blocksWrapperProps,
    contentWrapper: props.contentWrapper,
    contentWrapperProps: props.contentWrapperProps,
    trustedHosts: props.trustedHosts
  }));
}
var _default = exports.default = ContentVariants;
//# sourceMappingURL=content-variants.js.map