"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.needsElementRefDivForEditing = exports.SDKS_USING_ELEMENT_REF_APPROACH = void 0;
var _target = require("../../../constants/target");
var _isEditing = require("../../../functions/is-editing");
var _isPreviewing = require("../../../functions/is-previewing");
/**
 * SDKS that use the elementRef approach to enable visual editing.
 * We don't need to render the div for other SDKs as they attach event listeners to the window.
 */
const SDKS_USING_ELEMENT_REF_APPROACH = exports.SDKS_USING_ELEMENT_REF_APPROACH = ['svelte', 'qwik', 'vue'];

/**
 * We need to attach this div only when content exists or isPreviewing/isEditing even when content is null,
 * as we need to set the elementRef and allow previewing and visual editing
 */
const needsElementRefDivForEditing = () => {
  return SDKS_USING_ELEMENT_REF_APPROACH.includes(_target.TARGET) && ((0, _isEditing.isEditing)() || (0, _isPreviewing.isPreviewing)());
};
exports.needsElementRefDivForEditing = needsElementRefDivForEditing;
//# sourceMappingURL=enable-editor.helpers.js.map