"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createCssClass = exports.convertStyleMapToCSSArray = exports.convertStyleMapToCSS = void 0;
var _camelToKebabCase = require("../functions/camel-to-kebab-case");
var _nullable = require("./nullable");
const convertStyleMapToCSSArray = style => {
  const cssProps = Object.entries(style).map(([key, value]) => {
    if (typeof value === 'string') {
      return `${(0, _camelToKebabCase.camelToKebabCase)(key)}: ${value};`;
    } else {
      return undefined;
    }
  });
  return cssProps.filter(_nullable.checkIsDefined);
};
exports.convertStyleMapToCSSArray = convertStyleMapToCSSArray;
const convertStyleMapToCSS = style => convertStyleMapToCSSArray(style).join('\n');
exports.convertStyleMapToCSS = convertStyleMapToCSS;
const createCssClass = ({
  mediaQuery,
  className,
  styles
}) => {
  const cssClass = `.${className} {
    ${convertStyleMapToCSS(styles)}
  }`;
  if (mediaQuery) {
    return `${mediaQuery} {
      ${cssClass}
    }`;
  } else {
    return cssClass;
  }
};
exports.createCssClass = createCssClass;
//# sourceMappingURL=css.js.map