function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import * as React from 'react';
import { Text } from 'react-native';
import BuilderContext from "../context/builder.context";

/**
 * Implements CSS-like inheritance for `Text` by replacing all calls to `Text` with a custom `BaseText` component that
 * applies the `inheritedStyles` context styles, which contain all styles from all parents that might apply to a `Text`.
 */
export default function BaseText(props) {
  const builderContext = React.useContext(BuilderContext);
  return /*#__PURE__*/React.createElement(Text, _extends({}, props, {
    style: {
      ...builderContext.inheritedStyles,
      ...props.style
    }
  }));
}
//# sourceMappingURL=BaseText.js.map