import * as React from 'react';
import { Image as ReactImage, View } from 'react-native';
export default function Image(props) {
  var _props$builderBlock;
  const shouldRenderUnwrappedChildren = props.fitContent && ((_props$builderBlock = props.builderBlock) === null || _props$builderBlock === void 0 || (_props$builderBlock = _props$builderBlock.children) === null || _props$builderBlock === void 0 ? void 0 : _props$builderBlock.length);
  const imageStyle = props.aspectRatio ? {
    position: 'absolute',
    top: 0,
    bottom: 0,
    left: 0,
    right: 0
  } : {
    position: 'relative',
    ...(props.width ? {
      width: props.width
    } : {}),
    ...(props.height ? {
      height: props.height
    } : {})
  };
  const paddingTop = `${props.aspectRatio * 100}%`;
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(ReactImage, {
    resizeMode: props.backgroundSize || 'contain',
    style: imageStyle,
    source: {
      uri: props.image
    }
  }), props.aspectRatio && !shouldRenderUnwrappedChildren ? /*#__PURE__*/React.createElement(View, {
    style: {
      width: '100%',
      paddingTop
    }
  }) : null), shouldRenderUnwrappedChildren && props.children, !props.fitContent && props.children &&
  /*#__PURE__*/
  // When `fitContent: false`, we wrap image children ssuch that they stretch across the entire image
  React.createElement(View, {
    style: {
      display: 'flex',
      flexDirection: 'column',
      alignItems: 'stretch',
      position: 'absolute',
      top: 0,
      left: 0,
      width: '100%',
      height: '100%'
    }
  }, props.children));
}
//# sourceMappingURL=image.js.map