"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var React = _react;
var _reactNative = require("react-native");
var _isEditing = require("../../functions/is-editing");
var _logger = require("../../helpers/logger");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function CustomCode(props) {
  const elementRef = (0, _react.useRef)(null);
  const [scriptsInserted, setScriptsInserted] = (0, _react.useState)(() => []);
  const [scriptsRun, setScriptsRun] = (0, _react.useState)(() => []);
  function runScripts() {
    var _elementRef$current;
    if (!elementRef.current || !((_elementRef$current = elementRef.current) !== null && _elementRef$current !== void 0 && _elementRef$current.getElementsByTagName) || typeof window === "undefined") {
      return;
    }
    const scripts = elementRef.current.getElementsByTagName("script");
    for (let i = 0; i < scripts.length; i++) {
      const script = scripts[i];
      if (script.src) {
        if (scriptsInserted.includes(script.src)) {
          continue;
        }
        scriptsInserted.push(script.src);
        const newScript = document.createElement("script");
        newScript.async = true;
        newScript.src = script.src;
        document.head.appendChild(newScript);
      } else if (!script.type || ["text/javascript", "application/javascript", "application/ecmascript"].includes(script.type)) {
        if (scriptsRun.includes(script.innerText)) {
          continue;
        }
        try {
          scriptsRun.push(script.innerText);
          new Function(script.innerText)();
        } catch (error) {
          _logger.logger.warn("[BUILDER.IO] `CustomCode`: Error running script:", error);
        }
      }
    }
  }
  (0, _react.useEffect)(() => {
    runScripts();
  }, []);
  (0, _react.useEffect)(() => {
    if ((0, _isEditing.isEditing)()) {
      runScripts();
    }
  }, [props.code]);
  return /*#__PURE__*/React.createElement(_reactNative.View, {
    ref: elementRef,
    dangerouslySetInnerHTML: {
      __html: props.code
    }
  });
}
var _default = exports.default = CustomCode;
//# sourceMappingURL=custom-code.js.map