"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var React = _interopRequireWildcard(require("react"));
var _getBlockActions = require("../../../functions/get-block-actions");
var _getBlockProperties = require("../../../functions/get-block-properties");
var _dynamicRenderer = _interopRequireDefault(require("../../dynamic-renderer/dynamic-renderer"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
/**
 * This component renders a block's wrapper HTML element (from the block's `tagName` property).
 */

function BlockWrapper(props) {
  return /*#__PURE__*/React.createElement(_dynamicRenderer.default, {
    TagName: props.Wrapper,
    attributes: (0, _getBlockProperties.getBlockProperties)({
      block: props.block,
      context: props.context
    }),
    actionAttributes: (0, _getBlockActions.getBlockActions)({
      block: props.block,
      rootState: props.context.rootState,
      rootSetState: props.context.rootSetState,
      localState: props.context.localState,
      context: props.context.context,
      stripPrefix: true
    })
  }, props.children);
}
var _default = exports.default = BlockWrapper;
//# sourceMappingURL=block-wrapper.js.map