"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var React = _react;
var _reactNative = require("react-native");
var _isEditing = require("../../functions/is-editing");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function BlocksWrapper(props) {
  const blocksWrapperRef = (0, _react.useRef)(null);
  const [shouldUpdate, setShouldUpdate] = (0, _react.useState)(() => false);
  function className() {
    var _props$blocks;
    return ["builder-blocks", !((_props$blocks = props.blocks) !== null && _props$blocks !== void 0 && _props$blocks.length) ? "no-blocks" : "", props.classNameProp].filter(Boolean).join(" ");
  }
  function dataPath() {
    if (!props.path) {
      return undefined;
    }
    const thisPrefix = "this.";
    const pathPrefix = "component.options.";
    return props.path.startsWith(thisPrefix) ? props.path.replace(thisPrefix, "") : props.path.startsWith(pathPrefix) ? props.path : `${pathPrefix}${props.path || ""}`;
  }
  function onClick() {
    var _props$blocks2;
    if ((0, _isEditing.isEditing)() && !((_props$blocks2 = props.blocks) !== null && _props$blocks2 !== void 0 && _props$blocks2.length)) {
      var _window$parent;
      (_window$parent = window.parent) === null || _window$parent === void 0 || _window$parent.postMessage({
        type: "builder.clickEmptyBlocks",
        data: {
          parentElementId: props.parent,
          dataPath: dataPath()
        }
      }, "*");
    }
  }
  function onMouseEnter() {
    var _props$blocks3;
    if ((0, _isEditing.isEditing)() && !((_props$blocks3 = props.blocks) !== null && _props$blocks3 !== void 0 && _props$blocks3.length)) {
      var _window$parent2;
      (_window$parent2 = window.parent) === null || _window$parent2 === void 0 || _window$parent2.postMessage({
        type: "builder.hoverEmptyBlocks",
        data: {
          parentElementId: props.parent,
          dataPath: dataPath()
        }
      }, "*");
    }
  }
  (0, _react.useEffect)(() => {
    if ((0, _isEditing.isEditing)()) {
      /**
       * React Native strips off custom HTML attributes, so we have to manually set them here
       * to ensure that blocks are correctly dropped into the correct parent.
       */
      if (dataPath()) {
        blocksWrapperRef.current.setAttribute("builder-path", dataPath());
      }
      if (props.parent) {
        blocksWrapperRef.current.setAttribute("builder-parent-id", props.parent);
      }
    }
  }, []);
  (0, _react.useEffect)(() => {}, [props.blocks]);
  return /*#__PURE__*/React.createElement(props.BlocksWrapper, _extends({
    ref: blocksWrapperRef,
    "builder-path": dataPath(),
    "builder-parent-id": props.parent,
    dataSet: {
      class: className()
    },
    style: {
      ...styles.propsBlocksWrapper1,
      ...props.styleProp
    },
    onClick: event => onClick(),
    onMouseEnter: event => onMouseEnter(),
    onKeyPress: event => onClick()
  }, props.BlocksWrapperProps), props.children);
}
const styles = _reactNative.StyleSheet.create({
  propsBlocksWrapper1: {
    display: "flex",
    flexDirection: "column"
  }
});
var _default = exports.default = BlocksWrapper;
//# sourceMappingURL=blocks-wrapper.js.map