"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _logger = require("../helpers/logger");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
class ErrorBoundary extends _react.default.Component {
  constructor(props) {
    super(props);
    this.state = {
      hasError: false
    };
  }
  static getDerivedStateFromError(_error) {
    // Update state so the next render will show the fallback UI.
    return {
      hasError: true
    };
  }
  componentDidCatch(error, info) {
    _logger.logger.error('ErrorBoundary caught error:', info.error, info.componentStack);
  }
  render() {
    if (this.state.hasError) {
      return /*#__PURE__*/_react.default.createElement("p", null, "Builder.io SDK: error while rendering block. See console for full logs.");
    }
    return this.props.children;
  }
}
exports.default = ErrorBoundary;
//# sourceMappingURL=error-boundary.js.map