"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.normalizeSearchParams = exports.getSearchString = exports.convertSearchParamsToQueryObject = void 0;
const convertSearchParamsToQueryObject = searchParams => {
  const options = {};
  searchParams.forEach((value, key) => {
    options[key] = value;
  });
  return options;
};
exports.convertSearchParamsToQueryObject = convertSearchParamsToQueryObject;
const normalizeSearchParams = searchParams => searchParams instanceof URLSearchParams ? convertSearchParamsToQueryObject(searchParams) : searchParams;
exports.normalizeSearchParams = normalizeSearchParams;
const getSearchString = search => {
  if (typeof search === 'string') {
    return search;
  } else if (search instanceof URLSearchParams) {
    return search.toString();
  }
  return new URLSearchParams(search).toString();
};
exports.getSearchString = getSearchString;
//# sourceMappingURL=search.js.map