import { isBrowser } from "./is-browser";
import { serializeIncludingFunctions } from "./register-component";
const registry = {};
export function register(type, info) {
  if (type === 'plugin') {
    info = serializeIncludingFunctions(info);
  }
  let typeList = registry[type];
  if (!typeList) {
    typeList = registry[type] = [];
  }
  typeList.push(info);
  if (isBrowser()) {
    const message = {
      type: 'builder.register',
      data: {
        type,
        info
      }
    };
    try {
      parent.postMessage(message, '*');
      if (parent !== window) {
        window.postMessage(message, '*');
      }
    } catch (err) {
      console.debug('Could not postmessage', err);
    }
  }
}
export function registerAction(action) {
  if (isBrowser()) {
    var _window$parent;
    const actionClone = JSON.parse(JSON.stringify(action));
    if (action.action) {
      actionClone.action = action.action.toString();
    }
    (_window$parent = window.parent) === null || _window$parent === void 0 || _window$parent.postMessage({
      type: 'builder.registerAction',
      data: actionClone
    }, '*');
  }
}
//# sourceMappingURL=register.js.map