import type { Target } from '../../../types/targets';
/**
 * SDKS that use the elementRef approach to enable visual editing.
 * We don't need to render the div for other SDKs as they attach event listeners to the window.
 */
export declare const SDKS_USING_ELEMENT_REF_APPROACH: Target[];
/**
 * We need to attach this div only when content exists or isPreviewing/isEditing even when content is null,
 * as we need to set the elementRef and allow previewing and visual editing
 */
export declare const needsElementRefDivForEditing: () => boolean;
//# sourceMappingURL=enable-editor.helpers.d.ts.map